#include "scene.h"
#include "linesegment.h"
#include "triangle.h"

Scene *scene;

#include <iostream>

using namespace std;


Scene::Scene() {

  gui = new GUI();
  gui->show();

  int u0 = 0;
  int v0 = 0;
  int w = 640;
  int h = 480;
  fb = new FrameBuffer(u0, v0, w, h);
  unsigned int colors[2] = {0xFFFFFFFF, 0xFF0000FF};
  int cw = 32;
  fb->SetChecker(cw, colors);
  fb->label("Frame Buffer");
  fb->show();

  gui->uiw->position(fb->w+20, 40);

}

void Scene::DBG() {

/*
  FrameBuffer *im = new FrameBuffer;
  im->Load("images/imageSmall.tif");
  im->show();
  return;
*/

  V3 C(120.0f, 35.0f, 0.0f);
  float r = 23.45f;
  int left = (int) (C[0]-r);
  int right = (int) (C[0]+r);
  int top = (int) (C[1]-r);
  int bottom = (int) (C[1]+r);
  for (int v = top; v <= bottom; v++) {
    for (int u = left; u <= right; u++) {
      V3 P(.5f+(int)u, .5f+(int)v, 0.0f);
      if ((P-C).Length() > r)
        continue;
      fb->SetGuarded(.5f+(int)u, .5f+(int)v, 0xFF00FF00);
    }
  }
  fb->redraw();

  return;


  fb->Load("images/imageSmall.tif");
  fb->redraw();
  FrameBuffer *edgeMap = 0;
  fb->EdgeMap(edgeMap);
  edgeMap->show();
  return;
  
  cerr << "INFO: released DBG button" << endl;
  fb->Set(0xFFFFFFFF);
  V3 V0(20.0f, 400.0f, 1.0f);
  V3 V1(520.0f, 440.0f, 1.0f);
  V3 V2(150.0f, 100.0f, 1.0f);
  Triangle tri(V0, V1, V2);
  tri.Rasterize(fb, 0xFF00AAFF);
//  tri.DrawWireframe(fb, 0xFF000000);
  fb->redraw();

}