#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

class FrameBuffer : public Fl_Gl_Window {
public:
  unsigned int *pix;
  int w, h;
  FrameBuffer(int u0, int v0, int _w, int _h);
  FrameBuffer();
  void Set(unsigned int color);
  void draw();
  void SetChecker(int cw, unsigned int colors[2]);
  void Set(int u, int v, unsigned int color);
  unsigned int Get(int u, int v);
  void SetGuarded(float uf, float vf, unsigned int color);
  void EdgeMap(FrameBuffer *&edgeMap);
  int Load(char *tiffFileName);
};
